//+------------------------------------------------------------------+
//|                                                     Momentum.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#define		MB_OK		0
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
//---- input parameters
extern int MomPeriod=14;
extern double	AlarmLevel=100;
extern bool		SoundOn	= true;
extern bool		Visual	= true;
//---- buffers
double MomBuffer[];

double	ValueSave=0;
int		TimeSave=0;
int		TimeTick;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MomBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Mom("+MomPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   SetLevelValue(1,AlarmLevel);
	TimeSave=TimeCurrent();
	TimeSave=TimeSave-TimeSeconds(TimeSave);
  	TimeSave=MathFloor(TimeSave/Period());
  	
//----
   SetIndexDrawBegin(0,MomPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=MomPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=MomPeriod;i++) MomBuffer[Bars-i]=0.0;
//----
   i=Bars-MomPeriod-1;
   if(counted_bars>=MomPeriod) i=Bars-counted_bars-1;
   while(i>=0){
      MomBuffer[i]=Close[i]*100/Close[i+MomPeriod];
      i--;
     }
	if ((ValueSave==0)&&(MomBuffer[0]!=AlarmLevel)) ValueSave=MomBuffer[0];
	TimeTick=TimeCurrent();
	TimeTick=TimeTick-TimeSeconds(TimeTick);
	TimeTick=MathFloor(TimeTick/Period());
	Print(TimeTick,"  ",TimeSave,"  ",ValueSave,"  ",Period());
	if (TimeTick==TimeSave) return;
	if (ValueSave!=MomBuffer[0]){
		if ((ValueSave<AlarmLevel)&&(MomBuffer[0]>AlarmLevel)) { 
			if (Visual==true) Alert(Symbol()+Period()+" -> Upper");
   		if (SoundOn==true) PlaySound("HighUp.wav");
   		ValueSave=MomBuffer[0];
   	}
   	if ((ValueSave>AlarmLevel)&&(MomBuffer[0]<AlarmLevel)) {
   		if (Visual==true) Alert(Symbol()+Period()+" -> Downer");
   		if (SoundOn==true) PlaySound("LowDown.wav");
   		ValueSave=MomBuffer[0];
   	}
   }
   return(0);
  }
//+------------------------------------------------------------------+